%define ver      1.0.6 
%define rel      1 
%define prefix   /usr
%define name  	 horde-core 

Summary: Core elements for the Horde Web Application Suite 
Name: %name 
Version: %ver
Release: %rel 
Group: Networking/Utilities 
Requires: mod-php3 >= 3.0.7, apache >= 1.3.4
Copyright: GPL
Source: ftp://ftp.horde.org/imp/horde-%{ver}.tar.gz
Source1: defaults.php3
Buildroot: /tmp/horde-%{ver}
Packager: Pablo Costa <pablo@ib.usp.br>
Url: http://www.horde.org/imp
Distribution: Contrib 

%description

 Core elements for the Horde Web Application Suite
 A set of PHP3 scripts that implement an web based application suite.

 This package is required to run other programs such as IMP which is
 a web based IMAP client.  Other applications will follow as soon
 as they are functional.

%prep

%setup -n horde

%build

%install
install -d $RPM_BUILD_ROOT/etc/horde
install -d $RPM_BUILD_ROOT/usr/share/horde
install -d $RPM_BUILD_ROOT/usr/doc/horde-core
        
cp -R * $RPM_BUILD_ROOT/usr/share/horde 
cd $RPM_BUILD_ROOT
rm usr/share/horde/COPYING 
touch etc/horde/build.opts 
cp %{SOURCE1} etc/horde 
cp usr/share/horde/config/{*.php3,*.html,*.txt} etc/horde 
mv usr/share/horde/config/examples usr/doc/horde-core 
mv usr/share/horde/config/scripts usr/doc/horde-core/examples
mv usr/share/horde/{README,TODO,INSTALL,HELP,CREDITS} usr/doc/horde-core 

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /usr/bin/perl --

#!/usr/bin/perl --
# Copyright 1998,1999 Ivan E. Moore II
# See /usr/doc/horde/copyright.
$|=1;

### If horde.lib exists ###
### Change permissions so that we can create a new horde.lib file ###

if (! (-s "/usr/share/horde/lib/horde.lib")) {
  system("chmod -R 644 /usr/share/horde/lib/*.lib >> /dev/null 2>&1");
}

if (-s "/usr/sbin/apache-ssl") {
  $srm='/etc/apache-ssl/srm.conf';
  $http='/etc/apache-ssl/httpd.conf';
} else {
  $srm='/etc/httpd/conf/srm.conf';
  $http='/etc/httpd/conf/httpd.conf';
}

sub loadconf ($$;$)
{
    $parameter = 'DocumentRoot';
    $default = $_[1];

    $file = (defined ($_[2]) ? $_[2] : "$http");
    $in = `egrep "^[:space:]*$parameter " $file 2> /dev/null| head -1`;
    $in =~ s/\s*$parameter //;
    chomp ($in);
    return $in if ($in ne "");
    return $default;
}

sub load_conf ($$;$)
{
    my $parameter = $_[0];
    my $default = $_[1];

    my $file = (defined ($_[2]) ? $_[2] : "$srm");
    my $in = `egrep "^[:space:]*$parameter " $file 2> /dev/null| head -1`;
    $in =~ s/\s*$parameter //;
    chomp ($in);
    return $in if ($in ne "");
    return $default;
}
$install_dir = loadconf ("DocumentRoot", $tmproot, $srm);

$buildopts ='/etc/horde/build.opts';

sub load_config_files ()
{
    $main::srmconf = `cat $srm`;
    $main::dirindex = load_conf ("DirectoryIndex",$tmpdirindex, $srm);
    $main::buildconf = (-f $buildopts ? `cat $buildopts`: '');

}

### build.opts configuration ###

$write_srmconf = 0;
$restart_apache = 0;
$write_buildopts = 0;

if (-s "/usr/bin/psql") {
                $database='postgres';
    } else {
      if (-s "/usr/bin/mysql") {
                 $database='mysql';
      } else {
                 $database='dummy';
      }
    }

sub add_features ()
{
  $dirindexnew='index.html index.php3 index.htm default.html index.cgi';
  print "\n\nNow verifying both Apache and PHP3 Configurations\n";
  if (! ($srmconf =~ m/.*DirectoryIndex\s+$dirindexnew/m))
  {
    $srmconf =~ s/^\s*DirectoryIndex.*/DirectoryIndex $dirindexnew/m;
    print "DirectoryIndex now $dirindexnew.\n";
    $write_srmconf++;
  }
  if (! ($database =~ dummy)) {
    if (! ($buildconf =~ m/.*database=*/m))
    {
        print "Setting $database as your database option in build.opts\n";
        $buildconf =~ s/$/\ndatabase=$database\n/s;
        $write_buildconf++;
    }
  }
    if (! ($srmconf =~ m/.*Alias\s+\/horde\/\s+\/usr\/share\/horde\//m))
    {
        print "Adding alias /horde/ -> /usr/share/horde/ to srm.conf.\n";
        $srmconf =~ s/$/\n# Added for HORDE\n/s;
        $srmconf =~ s/$/Alias \/horde\/ \/usr\/share\/horde\/\n/s;
    if (! ($srmconf =~ m/.*Alias\s+\/horde\s+\/usr\/share\/horde\//m))
    {
        $srmconf =~ s/$/Alias \/horde \/usr\/share\/horde\/\n/s;
    }
        $write_srmconf++;
    }

}

if (-s "/etc/horde/config") {

  print "\nLooks like a previous install, not going to touch your Apache\n
or PHP stuff so if you don't have something set right, don't blame me!\n";
} else {
  load_config_files ();
  add_features ();
  system ("echo 'Base Install\n' > /etc/horde/config");
}

if ($write_buildconf)
{
#    system ("savelog -c 100 $buildopts >> /dev/null 2>&1")
#        && die ("couldn't rotate $buildopts\n");
    open (CONF, ">$buildopts") || die ("couldn't open $buildopts\n");
    print CONF $buildconf;
    close (CONF);
}

if ($write_srmconf)
{
#    system ("savelog -c 100 $srm >> /dev/null 2>&1")
#        && die ("couldn't rotate $srm");
    open (CONF, ">$srm") || die ("couldn't open $srm");
    print CONF $srmconf;
    close (CONF);
    $restart_apache++;
}



### Build horde.lib ###

print "Building HORDE Libraries for your specific installation
";

 system("cd /usr/share/horde/lib/src && ./build.pl >> /dev/null 2>&1");

### Change file permissions for security ###

 system("chown -R nobody.root /usr/share/horde >> /dev/null 2>&1");
 system("chmod -R 555 /usr/share/horde/lib/*.lib >> /dev/null 2>&1");
 system("chmod 000 /usr/share/horde/setup.php3 >> /dev/null 2>&1");
 system("rm -f /usr/share/horde/config/* >> /dev/null 2>&1");
 system("ln -s /etc/horde/*.php3 /usr/share/horde/config/ >> /dev/null 2>&1");
 system("ln -s /etc/horde/*.txt /usr/share/horde/config/ >> /dev/null 2>&1");
 system("ln -s /etc/horde/*.html /usr/share/horde/config/ >> /dev/null 2>&1");
 system("chmod 555 /etc/horde/*.php3 >> /dev/null 2>&1");
 system("chmod 555 /etc/horde/*.txt >> /dev/null 2>&1");

### Done ###


%files
%defattr(-,root,root)
%config /etc/horde/
/usr/share/horde/
/usr/doc/horde-core/
